#include "logmsg.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#define LOGMSG_BUFLEN       1024

char logmsg_msgbuf[LOGMSG_BUFLEN];


int logmsg_init(const char *prefix) {
    char *x;

    logprefix = malloc(strlen(prefix)+1);
    strcpy(logprefix, prefix);

    x = getenv("LOGTHRESHOLD");
    if (x != NULL) {
        loglevel = (int)strtol(x, (char **)NULL, 10);
        if (loglevel < 0 || loglevel > 7) {
            loglevel = LOG_ERR;
        }
    } else
        loglevel = LOG_ERR;

    return 0;
}

int logmsg(int prio, char *fmt, ...) {
    va_list ap;

    if (prio > loglevel) return 0;

    if (fmt[strlen(fmt)-1] == '\n') {
        snprintf(logmsg_msgbuf, LOGMSG_BUFLEN, "%s%s", logprefix, fmt);
    } else {
        snprintf(logmsg_msgbuf, LOGMSG_BUFLEN, "%s%s\n", logprefix, fmt);
    }

    va_start(ap, fmt);
    vfprintf(stderr, logmsg_msgbuf, ap);
    va_end(ap);

    return 0;
}

